@echo off
REM SPOOL.BAT - Windows Printer Batch File
REM REV# CC.UT.06.10.04   Last Mod: 02/18/16 JED

REM Used to process UBL @ printers if listed in UTFMCQ/CQDATA, useful for barcode printing
REM Note that BBSPOOL is required in BBENV file

REM %SVR% is the default server
REM %BTMP% is the UBL tmp folder (e.g. \compu\tmp)
REM %TDIR% is the UBL textfiles share folder (e.g. \compu\TEXTFILES)
REM %BBENV% is the full path to the BBENV file, used to get the working drive letter

REM ==============   BEGIN editable variables   ==============
set SVR=localhost
set BTMP=%BBENV:~0,2%\compu\tmp
set TDIR=%BBENV:~0,2%\compu\TEXTFILES
REM ==============   END   editable variables   ==============

REM %1 is print job file name (full path)
REM %2 from UBL  is printer name WITH single quotes and without "@" ('SALESLASER')
REM %PTR% is the printer name without the quotes

set PTR=%2
set PTR=%PTR:~1,-1%

REM for UBL  the script checks %2 and prints to %PTR% (see section below)

GOTO SKIP_EXAMPLES

REM ==============   BEGIN examples and comments   ==============
    REM If a printer is on another server, specify full printer share path
    REM there is no CASE statement in DOS, so every IF is bracketed with GOTO END
    IF /I %2 == 'LEEOKI' (
      COPY %1 \\lee_PC\leeoki >NUL
      GOTO END
    )

    REM Need to prefix the data file? Use the "+" operator for COPY
    COPY C:\compu\USQLRW\HP17.PCL+%1 \\machine\printer >NUL

    REM Need to account for hyphens or spaces in the share name?
    IF /I %2 == 'Chicago1300' (
      COPY %1 \\%SVR%\HP1300-CM >NUL
      GOTO END
    )

    REM Here is an EXAMPLE setup with two "exceptions"

    REM - share name with spaces and hyphens on default server
    IF /I %2 == 'LASER2' (
      COPY %1 "\\%SVR%\LaserJet 2430-2" >NUL
      GOTO END
    )
    REM - share printer on a different server / PC
    IF /I %2 == 'LASER3' (
      COPY %1 "\\SERVER3\%PTR%" >NUL
      GOTO END
    )
    :DEFAULT_Example
    REM No special cases? Assume that printer is shared from %SVR%
    COPY %1 \\%SVR%\%PTR% >NUL
REM ==============   END   examples and comments   ==============
:SKIP_EXAMPLES

REM ==============   BEGIN printer exceptions   ==============
REM put exceptions here - see above for examples


REM ==============   END   printer exceptions   ==============
REM ==============   BEGIN DEFAULT BEHAVIOR   ==============
:DEFAULT
REM No special cases? Assume that printer is shared from %SVR%
COPY %1 \\%SVR%\%PTR% >NUL

:END
REM Clean up old tmp files
cd /D %BTMP%
forfiles /M tmp_*.txt /D -8 /C "cmd /c DEL @path"
REM keep a single copy of user's most recent job to a particular printer
COPY %1 %BTMP%\tmp_%username%_%PTR%.txt >NUL
REM Remove Temp File
DEL %1 >NUL

REM ==============   END   DEFAULT BEHAVIOR   ==============
